/***Function written By Spandana Makeneni 2010***/
#include<glylib.h>
/***This defines the average plane for an array of coor:$
::$
dinates according to puckering paramaters***/

coord_3D *get_puckering_parm(int n,coord_3D *r){
int jval[n];
int l;
double z[n];
double H1[n];
double H2[n];
double q[n];
double m1=0.0;
double n1=0.0;
double q1=0.0;
double M=0.0;
double N=0.0;
plane pval;//plane for returning the values of plane 
vectormag_3D Rj,Rcos,Rsin,R1,R2,R1xR2,avg_coord;
R1.i=R1.j=R1.k=R2.i=R2.j=R2.k=0;
avg_coord.i=avg_coord.j=avg_coord.k=0;
for(l=0;l<n;l++){
	jval[l]=l+1;//getting j vals for further equations
	}
for(l=0;l<n;l++){//for loop for calculating the Rj vals
	Rj.i= r[l].i;
	Rj.j= r[l].j;
	Rj.k= r[l].k;
	Rsin.i = (Rj.i*sin(2*PI*(jval[l]-1)/n));
	Rsin.j = (Rj.j*sin(2*PI*(jval[l]-1)/n));
	Rsin.k = (Rj.k*sin(2*PI*(jval[l]-1)/n));
	Rcos.i = (Rj.i*cos(2*PI*(jval[l]-1)/n));
	Rcos.j = (Rj.j*cos(2*PI*(jval[l]-1)/n));
	Rcos.k = (Rj.k*cos(2*PI*(jval[l]-1)/n));
	R1.i=R1.i+Rsin.i;
	R1.j=R1.j+Rsin.j;
	R1.k=R1.k+Rsin.k;
	R2.i=R2.i+Rcos.i;
	R2.j=R2.j+Rcos.j;
	R2.k=R2.k+Rcos.k;
	}
R1xR2 = get_crossprod(R1,R2);//cross prod of Rjs
//printf("the R1xR2 is %f %f %f %f\n",R1xR2.i,R1xR2.j,R1xR2.k,R1xR2.d);
//printf("the R1val is %f  %f\n",R1.i,R2.i);
//printf("the R2val is %f  %f\n",R1.j,R2.j);
//printf("the R3val is %f  %f\n",R1.k,R2.k);
pval.A = (R1xR2.i/R1xR2.d);
pval.B = (R1xR2.j/R1xR2.d);
pval.C = (R1xR2.k/R1xR2.d);
for(l=0;l<n;l++){//for loop for calculating the avg x,y,z coordinates
	avg_coord.i=avg_coord.i+r[l].i;
	avg_coord.j=avg_coord.j+r[l].j;
	avg_coord.k=avg_coord.k+r[l].k;
	}
avg_coord.i=(avg_coord.i/n);
avg_coord.j=(avg_coord.j/n);
avg_coord.k=(avg_coord.k/n);
//printf("the avg coords are %f %f %f\n",avg_coord.i,avg_coord.j,avg_coord.k);
pval.D= -(pval.A*avg_coord.i+pval.B*avg_coord.j+pval.C*avg_coord.k);
//printf("the dval is %f\n",pval.D);
for(l=0;l<n;l++){
	z[l]=(pval.A*r[l].i+pval.B*r[l].j+pval.C*r[l].k+pval.D)/1;
	H1[l]=(z[l]*cos(4*PI*(jval[l]-1)/n));
	H2[l]=(z[l]*sin(4*PI*(jval[l]-1)/n));
	//printf("z[l] is %f\n",z[l]);
	q[l]=z[l]*(pow((-1),jval[l]-1));
	//printf("q[l] is %f\n",q[l]);
	m1=m1+H1[l];
	n1=n1+H2[l];
	q1=q1+q[l];
	}
//printf("the m1 val is %f, n1 val is %f and q1 val is %f\n",m1,n1,q1);
double x=(1.0/3.0);
double y=(1.0/6.0);
coord_3D *parm; 
parm=(coord_3D*)calloc(2,sizeof(coord_3D));
M=m1*(sqrt(x));
N=-(n1*(sqrt(x)));
//printf("the M val is %f, N val is %f and q3 val is %f\n",M,N,Q3);
/*
    In the following, 
        parm[0].i = q_2
        parm[0].j = q_3
        parm[0].k = phi_2
        parm[1].i = Q
        parm[1].j = theta
        parm[1].k = phi
*/
parm[0].k=atan(N/M);  /* phi_2 */
parm[0].i = N/sin(parm[0].k); /* q_2 */
if(parm[0].i<0)
    {/* if the q_2<0 */
    parm[0].k += PI; /* rotate phi_2 by PI */
    parm[0].i = -parm[0].i; /* make q_2 positive */
    } 
if(parm[0].k<0)
    {/* if phi_2 is negative */
    parm[0].k += 2*PI; /* enforce acceptable range of phi_2 */
    }
parm[0].j = q1*(sqrt(y)); /* q_3 */ 
/* */
parm[1].i = sqrt ( M*M + N*N + parm[0].j*parm[0].j ); /* Q */
parm[1].k = parm[0].k;  /* phi = phi_2 */
parm[1].j = acos(parm[0].j/parm[1].i); /* theta = acos ( q_3 / Q ) */

//printf("the phi value is %f\n",parm.i);
//printf("the theta value is %f\n",parm.j);
//printf("the Q value is %f\n",parm.k;

return &parm[0];

}
