#include <glylib.h>

#define USAGE "\n\
\texe input.top input.crd input_file\n"

coord_3D *get_puckering_parm(int n,coord_3D *r);

int main(int argc,char *argv[]){


if(argc<4){mywhineusage("insufficient number of arguments on command line",USAGE);}
if(argc>4){mywhineusage("Too many arguments on command line",USAGE);}

assembly A;
int n=6;
coord_3D *m;
m=(coord_3D*)calloc(n,sizeof(coord_3D));
coord_3D *p;
p=(coord_3D*)calloc(2,sizeof(coord_3D));
int i,j=0,mi,ri,ai;
fileset Tset,Cset,Iset,Oset;
fileslurp Islurp;
char ctype;
char line[2000];
char string1[10000];
int test=0,size=1;
char *outfile;
outfile=(char*)calloc(16,sizeof(char));
sprintf(outfile,"%s","pucker_parm.txt");
Oset.F=myfopen(outfile,"w");
Tset.N=strdup(argv[1]);
A=load_amber_prmtop(Tset);
Cset.N=strdup(argv[2]);
Cset.F=myfopen(Cset.N,"r");
fgets(line,2000,Cset.F); /* get line 1 */
fgets(line,2000,Cset.F); /* get line 2 */
if(line[4]=='.'){ /* is the entry an integer or a float? */
ctype='c';
}
else{
ctype='r';
}
//printf("ctype is %c\n",ctype);
rewind(Cset.F);
int e=0;
Iset.N=strdup(argv[3]);
Iset.F=myfopen(Iset.N,"r");
Islurp=slurp_file(Iset);
char **atomnames;
atomnames=(char**)calloc(size,sizeof(char*));
//printf("Islurp.n is %d\n",Islurp.n);
for(i=0;i<Islurp.n;i++){
//printf("inside for \n");
	sscanf(Islurp.L[i],"%s",string1);
	atomnames[j]=strdup(string1);
//printf("%s\n",atomnames[j]);
//printf("j is %d\n",j);
	j++;
	atomnames=(char**)realloc(atomnames,(size+j*sizeof(char*)));
	}

j=0;
test=fgetc(Cset.F);
/*
    In the following, 
        p[0].i = q_2
        p[0].j = q_3
        p[0].k = phi_2
        p[1].i = Q
        p[1].j = theta
        p[1].k = phi
*/
fprintf(Oset.F,"Frame\tq_2\t\tq_3\t\tQ\t\tphi(_2)\t\ttheta\t\tphi(degrees)\ttheta(degrees)\n");
while(test != EOF){
	ungetc(test,Cset.F);
	add_trajcrds_to_prmtop_assembly(Cset,&A,ctype,0);
	fprintf(Oset.F,"%d\t",e);
	e++;
//printf("The number of molcules are %d\n",A.nm);
	for(mi=0;mi<A.nm;mi++){
		j=0;
		for(ri=0;ri<A.m[mi][0].nr;ri++){
			for(ai=0;ai<A.m[mi][0].r[ri].na;ai++){
				//printf("%s\n",A.m[mi][0].r[ri].a[ai].N);
				if(strstr(A.m[mi][0].r[ri].a[ai].N,atomnames[0]) != NULL){
//printf("%s\n",A.m[mi][0].r[ri].a[ai].N);
					m[0].i= A.m[mi][0].r[ri].a[ai].xa[0].i;
					m[0].j= A.m[mi][0].r[ri].a[ai].xa[0].j;
                                        m[0].k= A.m[mi][0].r[ri].a[ai].xa[0].k;
					}
				if(strstr(A.m[mi][0].r[ri].a[ai].N,atomnames[1]) != NULL){
//printf("%s\n",A.m[mi][0].r[ri].a[ai].N);
					m[1].i= A.m[mi][0].r[ri].a[ai].xa[0].i;
                                        m[1].j= A.m[mi][0].r[ri].a[ai].xa[0].j;
                                        m[1].k= A.m[mi][0].r[ri].a[ai].xa[0].k;
                                        }
				if(strstr(A.m[mi][0].r[ri].a[ai].N,atomnames[2]) != NULL){
//printf("%s\n",A.m[mi][0].r[ri].a[ai].N);
                                        m[2].i= A.m[mi][0].r[ri].a[ai].xa[0].i;
                                        m[2].j= A.m[mi][0].r[ri].a[ai].xa[0].j;
                                        m[2].k= A.m[mi][0].r[ri].a[ai].xa[0].k;
					}
				if(strstr(A.m[mi][0].r[ri].a[ai].N,atomnames[3]) != NULL){
//printf("%s\n",A.m[mi][0].r[ri].a[ai].N);
                                        m[3].i= A.m[mi][0].r[ri].a[ai].xa[0].i;
                                        m[3].j= A.m[mi][0].r[ri].a[ai].xa[0].j;
                                        m[3].k= A.m[mi][0].r[ri].a[ai].xa[0].k;
					}
				if(strstr(A.m[mi][0].r[ri].a[ai].N,atomnames[4]) != NULL){
//printf("%s\n",A.m[mi][0].r[ri].a[ai].N);
                                        m[4].i= A.m[mi][0].r[ri].a[ai].xa[0].i;
                                        m[4].j= A.m[mi][0].r[ri].a[ai].xa[0].j;
                                        m[4].k= A.m[mi][0].r[ri].a[ai].xa[0].k;
					}
				if(strstr(A.m[mi][0].r[ri].a[ai].N,atomnames[5]) != NULL){
//printf("%s\n",A.m[mi][0].r[ri].a[ai].N);
					m[5].i= A.m[mi][0].r[ri].a[ai].xa[0].i;
                                        m[5].j= A.m[mi][0].r[ri].a[ai].xa[0].j;
                                        m[5].k= A.m[mi][0].r[ri].a[ai].xa[0].k;
                                        }

					
				}
			}
		}
	
/*
    In the following, 
        p[0].i = q_2
        p[0].j = q_3
        p[1].i = Q
        p[0].k = phi_2
        p[1].j = theta
        --- redundant: p[1].k = phi

     q2 q_3 Q phi_2 theta phi(degrees) theta(degrees)
*/
	p=get_puckering_parm(n,m);
	double deg = 180.0/PI;
	fprintf(Oset.F,"%f\t%f\t%f\t%f\t%f\t%f\t%f\n",p[0].i,p[0].j,p[1].i,\
              p[0].k,p[1].j,deg*p[0].k,deg*p[1].j);
	test=fgetc(Cset.F);
	for(mi=0;mi<A.nm;mi++){
        	for(ri=0;ri<A.m[mi][0].nr;ri++){
                	for(ai=0;ai<A.m[mi][0].r[ri].na;ai++){
                                A.m[mi][0].r[ri].a[ai].nalt=0;
                                free(A.m[mi][0].r[ri].a[ai].xa);
                        } // close atom loop
                } // close residue loop

        }// cloise molecul

}
fclose(Oset.F);;
return 0;
}
